searchNodes=[{"ref":"Freight.html","title":"Freight","type":"module","doc":""},{"ref":"Freight.html#error_object/0","title":"Freight.error_object/0","type":"function","doc":"Gets an atom that is the name of the error object as used in payloads from the Application environment"},{"ref":"Freight.Helpers.Test.html","title":"Freight.Helpers.Test","type":"module","doc":"These helpers can be used in your ExUnit tests, while dealing with mutation payloads. Example test &quot;throws errors&quot; do map |&gt; assert_unsuccessful?() |&gt; assert_has_error?(&quot;this does not work this way&quot;) |&gt; assert_has_error?(&quot;and neither does this&quot;) end"},{"ref":"Freight.Helpers.Test.html#assert_has_error?/2","title":"Freight.Helpers.Test.assert_has_error?/2","type":"function","doc":"Checks whether the mutation returned an error with the given message in its payload"},{"ref":"Freight.Helpers.Test.html#assert_successful?/1","title":"Freight.Helpers.Test.assert_successful?/1","type":"function","doc":"Asserts whether the mutation was successful"},{"ref":"Freight.Helpers.Test.html#assert_unsuccessful?/1","title":"Freight.Helpers.Test.assert_unsuccessful?/1","type":"function","doc":"Asserts whether the mutation was not successful"},{"ref":"Freight.Integrations.Ecto.html","title":"Freight.Integrations.Ecto","type":"module","doc":"The ecto integration converts ecto changesets into error messages. You can pass a changeset as an error message, and Freight will interpret it and list its errors."},{"ref":"Freight.Integrations.Ecto.html#convert_error/1","title":"Freight.Integrations.Ecto.convert_error/1","type":"function","doc":"Converts a changeset to a list of error strings"},{"ref":"Freight.Payload.html","title":"Freight.Payload","type":"module","doc":""},{"ref":"Freight.Payload.html#build_error_object_default/0","title":"Freight.Payload.build_error_object_default/0","type":"macro","doc":"Builds the default error object, and puts this in the config of freight. NOTE: calling this overwrites your config Default error object object :payload_error do field(:message, type: :string) end"},{"ref":"Freight.Payload.html#build_payload/2","title":"Freight.Payload.build_payload/2","type":"function","doc":"Absinthe middleware function that creates a payload Usage Below shows the usage in an absinthe scheme @desc &quot;Delete a comment&quot; field :delete_comment, :comment_delete_payload do arg(:id, non_null(:id)) resolve(&amp;CommentsResolver.delete_comment/3) middleware(&amp;build_payload/2) end"},{"ref":"Freight.Payload.html#define_payload/2","title":"Freight.Payload.define_payload/2","type":"macro","doc":"Defines a payload object type with a given name and fields Error object By default an error object will be generated in build_error_object_default/0. If you&#39;d like to use a custom error object, configure this in your config.exs: config :freight, # where :user_error is the name of the type you&#39;d like to use as an error object error_object: :user_error Keyword list and map errors are automatically mapped to your error. Cangeset and string errors are mapped to the message property. Usage define_payload(:user_payload, user: :user, comment: :comment) creates the equilevant of object :user_payload do field(:successful, type: non_null(:boolean), description: &quot;Indicates whether the mutation completed successfully or not.&quot; ) field(:errors, type: list_of(:payload_error), description: &quot;A list of errors, raised when executing this migrations.&quot; ) field(:user, type: :user) field(:comment, type: :comment) end"},{"ref":"Freight.Payload.ErrorPayload.html","title":"Freight.Payload.ErrorPayload","type":"module","doc":"Error payloads are payloads that are created when an :error tuple has been returned. Their successful property is always set to false."},{"ref":"Freight.Payload.ErrorPayload.html#convert_error/1","title":"Freight.Payload.ErrorPayload.convert_error/1","type":"function","doc":"Converts any valid error value to an error object that can be supplied to the array of errors in a payload"},{"ref":"Freight.Payload.ErrorPayload.html#create_payload/1","title":"Freight.Payload.ErrorPayload.create_payload/1","type":"function","doc":"Manually generates a map representing a generic unsuccessful object. All customized result fields will not be defined, and thus returned as nil Usage create_payload([&quot;You are not signed in&quot;, &quot;Something else&quot;]) will return the following map %{ successful: false, errors: [&quot;You are not signed in&quot;, &quot;Something else&quot;] }"},{"ref":"Freight.Payload.SuccessPayload.html","title":"Freight.Payload.SuccessPayload","type":"module","doc":"Success payloads are payloads that are created when an :ok tuple has been returned. Their successful property is always set to true."},{"ref":"Freight.Payload.SuccessPayload.html#create_payload/1","title":"Freight.Payload.SuccessPayload.create_payload/1","type":"function","doc":"Manually generates a map representing a successful object. Omitted value will be returned as null in your graphql response. There is currently no checking for whether all values are provided. Usage create_payload(user: %User{}) will return the following map %{ successful: true, user: %User{} }"},{"ref":"readme.html","title":"Freight","type":"extras","doc":"Freight Freight is a library for Absinthe GraphQL that helps you build mutation payload results. Inspired by the GraphQL APIs of GitHub and Shopify, who also aim to keep syntactical GraphQL errors, like missing fields and malformed queries, seperate from validation and other business logic errors. It is heavily inspired by Kronky, I decided to build my own library because I did not like how much it is focussed on ecto changesets, and missed customisability that was required for a project I work on."},{"ref":"readme.html#configuration","title":"Freight - Configuration","type":"extras","doc":"You can set a custom error object that will be returned in the errors array in your payloads. This object must be defined in the schema you&#39;re calling define_payload from. config :freight, error_object: :user_error"},{"ref":"readme.html#usage","title":"Freight - Usage","type":"extras","doc":"Below is a documented example of how to define Freight payloads in your schema defmodule FreightDemo.Schema.Example do use Absinthe.Schema.Notation import Freight.Payload object :user do field(:name, :string) end object :comment do field(:body, :string) field(:author, :user) end define_payload(:create_comment_payload, author: :user, comment: :comment) field :create_comment, type: :create_comment_payload do arg(:body, non_null(:string)) resolve(&amp;FreightDemo.Resolver.create_comment/3) middleware(&amp;build_payload/2) end end Returning errors works just like in Absinthe defmodule FreightDemo.Resolver do def create_comment(_parent, %{body: body}, _context) do # your logic {:ok, author: %{}, comment: %{}} end # OR def create_comment(_parent, %{body: body}, _context) do # your logic {:error, &quot;Something went horribly wrong!&quot;} end end More extensive documentation on defining errors can be found in the documentation"},{"ref":"readme.html#installation","title":"Freight - Installation","type":"extras","doc":"Add the following to your mix.exs file def deps do [ {:freight, &quot;~&gt; 0.1.0&quot;} ] end Documentation can be found at https://hexdocs.pm/freight."}]